# Demonstration of two equivalent ways of calculating element addresses in
# x86-64 assembly. Note that ref_as is roughly analogous to ref_c and arith_as
# to arith_c. (That's not to say that using different C operators necessarily
# does anything different; rather, the point is that there are also multiple
# ways to do it in assembly.)
# Danger, W.R.! This file intentionally contains a bug that will probably result
# in a segmentation fault. Can you find it?
#
# Author: Sol Boucher <sboucher@cmu.edu>

.data
ref_as_tab:
	.quad ref_as_def
	.quad ref_as_1
	.quad ref_as_2
	.quad ref_as_def
	.quad ref_as_4
	.quad ref_as_def
	.quad ref_as_def
	.quad ref_as_def
	.quad ref_as_8

.text
.globl ref_as
ref_as:
	xor %rax, %rax
	mov %esi, %eax
	cmp $8, %edx
	ja  ref_as_def
	jmp *ref_as_tab(,%edx,8)
ref_as_1:
	lea (%rdi,%rax,1), %eax
	ret
ref_as_2:
	lea (%rdi,%rax,2), %eax
	ret
ref_as_4:
	lea (%rdi,%rax,4), %eax
	ret
ref_as_8:
	lea (%rdi,%rax,8), %eax
	ret
ref_as_def:
	xor %eax, %eax
	ret

.globl arith_as
arith_as:
	xor   %rax, %rax
	mov   %esi, %eax
	imul  %edx
	add   %rdi, %rax
	ret
