// Demonstration of three equivalent ways of calculating element addresses in C.
// This is intended as a reminder of the silent work done by pointer arithmetic.
//
// Author: Sol Boucher <sboucher@cmu.edu>

#include <stddef.h>
#include <stdint.h>

void *ref_c(void *buf, int idx, unsigned siz) {
	switch(siz) {
	case 1: {
		int8_t *arr = buf;
		return &arr[idx];
	} case 2: {
		int16_t *arr = buf;
		return &arr[idx];
	} case 4: {
		int32_t *arr = buf;
		return &arr[idx];
	} case 8: {
		int64_t *arr = buf;
		return &arr[idx];
	} default:
		return NULL;
	}
}

void *parith_c(void *buf, int idx, unsigned siz) {
	switch(siz) {
	case 1: {
		int8_t *arr = buf;
		return arr + idx;
	} case 2: {
		int16_t *arr = buf;
		return arr + idx;
	} case 4: {
		int32_t *arr = buf;
		return arr + idx;
	} case 8: {
		int64_t *arr = buf;
		return arr + idx;
	} default:
		return NULL;
	}
}

void *arith_c(void *buf, int idx, unsigned siz) {
	int8_t *arr = buf;
	return arr + idx * siz;
}
