# Example of how to implement some of the datalab challenges trivially in
# x86-64 assembly. Also illustrates the importance of complying with the
# conventions established by the platform ABI (Application Binary Interface)
# whenever C code is to be involved.
#
# Author: Sol Boucher <sboucher@cmu.edu>

.globl isNotEqual
isNotEqual:
	cmp   %esi, %edi
	setne %al
	movzx %al, %eax
	ret

.globl negate
negate:
	neg %edi
	mov %edi, %eax
	ret

.globl subOK
subOK:
	cmp   %esi, %edi
	setno %al
	movzx %al, %eax
	ret

.globl isGreater
isGreater:
	cmp   %esi, %edi
	setg  %al
	movzx %al, %eax
	ret

.globl bug
bug:
	xor %ebx, %ebx
	ret
