// Example program on which to demonstrate using GDB. See the Makefile for build
// instructions and useful reverse-engineering command examples.
//
// Author: Sol Boucher <sboucher@cmu.edu>

#include "addr.h"

#include <stdio.h>

#include "addr.h"
#include "data.h"

// Note that C's static is the exact opposite of assembly's .globl directive.

static int check_datalab(void) {
	int check = isNotEqual(1, 5) && negate(2) == -2 && subOK(1, 3) && isGreater(15213, 15112);
	bug(check);
	return check;
}

static int check_addrcalc(void) {
	char msg[] = "The quick, brown fox jumped over the lazy dog.";

	int match = 1;
	void *(*fun[])(void *, int, unsigned) = {
		ref_c,
		parith_c,
		arith_c,
		ref_as,
		arith_as,
	};
	for(int idx = 0; idx < sizeof fun / sizeof *fun; ++idx)
		match = match && *(char *)fun[idx](msg, 9, sizeof *msg) == ',';

	return match;
}

int main(void) {
	printf("Data lab working correctly? %d\n", check_datalab());
	printf("Address calculations agree? %d\n", check_addrcalc());
	return 0;
}
